import 'dart:async';

import 'package:firebase_database/firebase_database.dart';
import 'package:jt_firebase_flutter/jt_firebase_flutter.dart';
import 'package:jt_firebase_flutter/src/data_snapshot.dart';
import 'package:jt_firebase_flutter/src/reference.dart';

class JtEventFlutter implements FireblendEvent {
  Event _event;

  JtEventFlutter(this._event);

  @override
  JtDataSnapshotFlutter get snapshot =>
      JtDataSnapshotFlutter(this._event.snapshot);

  @override
  String get previousSiblingKey => this._event.previousSiblingKey;
}

class JtDbQueryFlutter extends FireblendQuery {
  final Query _query;

  JtDbQueryFlutter(this._query);

  @override
  Stream<JtEventFlutter> get onChildAdded =>
      this._query.onChildAdded.map<JtEventFlutter>(this._transformEvent);

  @override
  Stream<JtEventFlutter> get onChildChanged =>
      this._query.onChildChanged.map<JtEventFlutter>(this._transformEvent);

  @override
  Stream<JtEventFlutter> get onChildMoved =>
      this._query.onChildMoved.map<JtEventFlutter>(this._transformEvent);

  @override
  Stream<JtEventFlutter> get onChildRemoved =>
      this._query.onChildRemoved.map<JtEventFlutter>(this._transformEvent);

  @override
  Stream<JtEventFlutter> get onValue =>
      this._query.onValue.map<JtEventFlutter>(this._transformEvent);

  JtEventFlutter _transformEvent(Event event) {
    return JtEventFlutter(event);
  }

  @override
  JtDbQueryFlutter startAt(value, {String key}) {
    return JtDbQueryFlutter(this._query.startAt(value, key: key));
  }

  @override
  JtDbQueryFlutter endAt(value, {String key}) {
    return JtDbQueryFlutter(this._query.endAt(value, key: key));
  }

  @override
  JtDbQueryFlutter equalTo(value, {String key}) {
    return JtDbQueryFlutter(this._query.equalTo(value, key: key));
  }

  @override
  JtDbQueryFlutter orderByChild(String key) {
    return JtDbQueryFlutter(this._query.orderByChild(key));
  }

  @override
  JtDbQueryFlutter orderByKey() {
    return JtDbQueryFlutter(this._query.orderByKey());
  }

  @override
  JtDbQueryFlutter orderByPriority() {
    return JtDbQueryFlutter(this._query.orderByPriority());
  }

  @override
  JtDbQueryFlutter orderByValue() {
    return JtDbQueryFlutter(this._query.orderByValue());
  }

  @override
  JtDbQueryFlutter limitToFirst(int limit) {
    return JtDbQueryFlutter(this._query.limitToFirst(limit));
  }

  @override
  JtDbQueryFlutter limitToLast(int limit) {
    return JtDbQueryFlutter(this._query.limitToLast(limit));
  }

  @override
  Future<FireblendDataSnapshot> once() async {
    return JtDataSnapshotFlutter(await this._query.once());
  }

  @override
  Map<String, dynamic> getParameters() {
    throw Exception('Not implemented JtDbQueryFlutter.getParameters()!');
  }

  @override
  String getPath() {
    return this._query.path;
  }

  @override
  JtDbReferenceFlutter reference() {
    return JtDbReferenceFlutter(this._query.reference());
  }
}
