import 'package:firebase_database/firebase_database.dart';
import 'package:jt_firebase_flutter/jt_firebase_flutter.dart';
import 'package:jt_firebase_flutter/src/data_snapshot.dart';
import 'package:jt_firebase_flutter/src/on_disconnect.dart';
import 'package:jt_firebase_flutter/src/query.dart';

class JtDbReferenceFlutter extends JtDbQueryFlutter
    implements FireblendDatabaseReference {
  final DatabaseReference _ref;

  JtDbReferenceFlutter(this._ref) : super(_ref);

  @override
  String get key => this._ref.key;

  @override
  JtDbReferenceFlutter child(String path) {
    return JtDbReferenceFlutter(this._ref.child(path));
  }

  @override
  JtDbReferenceFlutter parent() {
    return JtDbReferenceFlutter(this._ref.parent());
  }

  @override
  JtDbReferenceFlutter root() {
    return JtDbReferenceFlutter(this._ref.root());
  }

  @override
  Future<FireblendDatabaseReference> push([dynamic value]) async {
    final ref = JtDbReferenceFlutter(this._ref.push());
    await ref.set(value);
    return ref;
  }

  @override
  Future<void> set(value, {priority}) {
    return this._ref.set(value, priority: priority);
  }

  @override
  Future<void> setPriority(priority) {
    return this._ref.setPriority(priority);
  }

  @override
  Future<void> update(Map<String, dynamic> value) {
    return this._ref.update(value);
  }

  @override
  Future<void> remove() {
    return this._ref.remove();
  }

  @override
  Future<FireblendDataSnapshot> transaction(Function function) async {
    final result = await this._ref.runTransaction(function);
    return JtDataSnapshotFlutter(result.dataSnapshot);
  }

  @override
  JtOnDisconnectFlutter onDisconnect() {
    return JtOnDisconnectFlutter(this._ref.onDisconnect());
  }
}
